=== dist/CMakeLists.txt ===
# Generated by tools/make_src_dist.py
set(GIT_COMMIT_HASH "9f30593b4" PARENT_SCOPE)

# Pre-generated `devilutionx.mpq` is provided so that distributions do not have to depend on smpq.
set(DEVILUTIONX_MPQ "${CMAKE_CURRENT_SOURCE_DIR}/devilutionx.mpq" PARENT_SCOPE)

# This would ensure that CMake does not attempt to connect to network.
# We do not set this to allow for builds for Windows and Android, which do fetch some
# dependencies even with this source distribution.
# set(FETCHCONTENT_FULLY_DISCONNECTED ON PARENT_SCOPE)

# Set the path to each dependency that must be vendored:
set(FETCHCONTENT_SOURCE_DIR_ASIO "${CMAKE_CURRENT_SOURCE_DIR}/asio-src" CACHE STRING "")
set(FETCHCONTENT_SOURCE_DIR_LIBMPQ "${CMAKE_CURRENT_SOURCE_DIR}/libmpq-src" CACHE STRING "")
set(FETCHCONTENT_SOURCE_DIR_LIBSMACKERDEC "${CMAKE_CURRENT_SOURCE_DIR}/libsmackerdec-src" CACHE STRING "")
set(FETCHCONTENT_SOURCE_DIR_LIBZT "${CMAKE_CURRENT_SOURCE_DIR}/libzt-src" CACHE STRING "")
set(FETCHCONTENT_SOURCE_DIR_SDL_AUDIOLIB "${CMAKE_CURRENT_SOURCE_DIR}/sdl_audiolib-src" CACHE STRING "")
set(FETCHCONTENT_SOURCE_DIR_SIMPLEINI "${CMAKE_CURRENT_SOURCE_DIR}/simpleini-src" CACHE STRING "")
