=== 3rdParty/PKWare/CMakeLists.txt ===
add_library(PKWare STATIC
  explode.cpp
  implode.cpp)
target_include_directories(PKWare PUBLIC .)
